// ==================================================================
//
// Class Name
//  EmailManager
//
// Last date of modification
//  15 April 2001
//
// Description
//  This java class will build and send an email message.
//  Requires J2EE to be installed.
//
// Input
//  none
//
// Author
//  Roger Lacroix
//
// ------------------------------------------------------------------
import java.io.*;
import java.util.*;
import javax.mail.*;
import javax.mail.internet.*;

public class EmailManager
{
  private  String SMTPHostAddress;
  private  String SMTPFromEmailAddress;
  private  String EmailNameList="";
  private  String doSendMail;
  private  boolean boolDoSendMail;
  private  String EmailSubject;
  private  String EmailBody;
  private  Vector vector_InternetAddress_SMTP_To = new Vector();
  private  int numEmailRecipient=0;

  public EmailManager()
  {
     super();
  }

  public void SendEmail()  throws javax.mail.MessagingException
  {
     String value;
     InternetAddress internetAddress;

     // Get system properties
     Properties SystemProps = System.getProperties();

     //

     if ( !boolDoSendMail )
     {
         return;
     }

     //
     System.out.println("SendEmail:\t\t"+ doSendMail);
     System.out.println("SMTPHostAddress:\t"+ SMTPHostAddress);
     System.out.println("SMTPFromEmailAddress:\t"+ SMTPFromEmailAddress);
     System.out.println("EmailName:\t\t"+ EmailNameList);
     System.out.println("Number of Email Recipients: "+ numEmailRecipient);
     System.out.println("EmailSubject:\t\t"+ EmailSubject);
     System.out.println("EmailBody:\t\t"+ EmailBody);

     // Setup mail server
     SystemProps.put("mail.smtp.host", SMTPHostAddress );

     // Get session
     Session session = Session.getInstance(SystemProps, null);

     // Define message
     MimeMessage message = new MimeMessage(session);

     Address SMTPFrom = new InternetAddress(SMTPFromEmailAddress);
     message.setFrom(SMTPFrom);

     //
     Address[] array_Address = new Address[numEmailRecipient];

     vector_InternetAddress_SMTP_To.toArray(array_Address);

     message.addRecipients(Message.RecipientType.TO, array_Address);

     message.setSubject(EmailSubject);
     message.setText(EmailBody);

     // Send message
     Transport.send(message);

     vector_InternetAddress_SMTP_To.removeAllElements();
     internetAddress = null;
     session = null;
     System.out.println("Mail sent sucessfully at "+ new Date());
  }  // end method

  //

  public void SetDoSendMail(String InputString)
  {
     //Process boolean value
     doSendMail = InputString.trim();

     Boolean sendMail = new Boolean(doSendMail);

     boolDoSendMail = sendMail.booleanValue();
  }

  //
  public void SetSMTPHostAddress(String InputString)
  {
     SMTPHostAddress = InputString.trim();
  }

  //
  public String GetSMTPHostAddress()
  {
     return SMTPHostAddress;
  }

  //
  public void SetSMTPFromEmailAddress(String InputString)
  {
     SMTPFromEmailAddress = InputString.trim();
  }

  //
  public String GetSMTPFromEmailAddress()
  {
     return SMTPFromEmailAddress;
  }

  //
  public void SetToAddress(String InputString)
  {
     String value;
     StringTokenizer tokenizer = new StringTokenizer( InputString, ",;" );
     InternetAddress internetAddress;

     EmailNameList = EmailNameList + InputString.trim() + " ";

     try
     {
        while(tokenizer.hasMoreElements())
        {
            value = (String)tokenizer.nextElement();
            value = value.trim();
            internetAddress = new InternetAddress(value);
            vector_InternetAddress_SMTP_To.add(internetAddress);

            numEmailRecipient++;
        }
     }
     catch (MessagingException ex)
     {
        System.out.println("Oops SetToAddress - Messaging Exception: " + ex);
        ex.printStackTrace ();
     }
  }  // end method

  //
  public String GetToAddress()
  {
     return EmailNameList;
  }

  //
  public void SetEmailSubject(String InputString)
  {
     EmailSubject = InputString.trim();
  }

  //
  public String GetEmailSubject()
  {
     return EmailSubject;
  }

  //
  public void SetEmailBody(String InputString)
  {
     EmailBody = InputString;
  }

  //
  public String GetEmailBody()
  {
     return EmailBody;
  }
}

